<script setup lang="ts">

import { useRangeDateReceiptStore } from '@/stores/getReceiptRange';
import { useLoadingStore } from '@/stores/loading';

import { computed, onMounted, ref } from 'vue'
import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend
} from 'chart.js'
import { Line } from 'vue-chartjs'
import * as chartConfig from './chartConfig.js'
ChartJS.register(
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend
)
const dialog = ref(false)
const toggleDialog = () => {
  dialog.value = !dialog.value
}
const loadingStore = useLoadingStore()
const selectedStartDate = ref(null)
const selectedEndDate = ref(null)
function formatDate(date: Date) {
  if (!date) return null

  const day = date.getDate().toString().padStart(2, '0')
  const month = (date.getMonth() + 1).toString().padStart(2, '0')
  const year = date.getFullYear()

  return `${day}-${month}-${year}`
}
const formattedStartDate = computed(() => {
  if (selectedStartDate.value) {
    return formatDate(selectedStartDate.value);
  }
  return '';
});

const formattedEndDate = computed(() => {
  if (selectedEndDate.value) {
    return formatDate(selectedEndDate.value);
  }
  return '';
});

function combineDates(startDate: any, endDate: any) {
  const formattedStartDate = formatDate(startDate.value)
  const formattedEndDate = formatDate(endDate.value)

  return `${formattedStartDate} - ${formattedEndDate}`
}
const dateRange = ref('Select range Date')
const confirmSetbutton = () => {
  dateRange.value = combineDates(selectedStartDate, selectedEndDate)
}

const chartData = ref({
  labels: [],
  datasets: [{ label: 'Data One', backgroundColor: '#f87979', data: [] }]
})
const chartOptions = { responsive: true }



const rangeDateReceiptStore = useRangeDateReceiptStore()


const items = ref(['day', 'month', 'year'])
const reportTypeSelected = ref('day')
onMounted(async () => {
  const currentDate = new Date(); // Current date
  const endDate = new Date(); // End date (current date)
  const startDate = new Date(); // Start date (current date - 30 days)

  startDate.setDate(currentDate.getDate() - 30); // Subtract 30 days from current date

  // Format dates as "d-m-y"
  const formattedStartDateValueOnMount = `${startDate.getDate()}-${startDate.getMonth() + 1}-${startDate.getFullYear()}`;
  const formattedEndDateValueOnMount = `${endDate.getDate()}-${endDate.getMonth() + 1}-${endDate.getFullYear()}`;

  dateRange.value = formattedStartDateValueOnMount + "-" + formattedEndDateValueOnMount

  // Call the function with default arguments
  await rangeDateReceiptStore.getReceiptInRangeDate("day", formattedStartDateValueOnMount, formattedEndDateValueOnMount);
  await getView(); // Call getView after data is fetched
});
const labels = ref()

async function getView() {
  loadingStore.doLoad()
  if (reportTypeSelected.value === "day") {
    labels.value = rangeDateReceiptStore.receipts.map((item: any) => {
      return item.Date
    })

  } else if (reportTypeSelected.value === "month") {
    labels.value = rangeDateReceiptStore.receipts.map((item: any) => {
      return item.Month
    })

  } else if (reportTypeSelected.value === "year") {
    labels.value = rangeDateReceiptStore.receipts.map((item: any) => {
      return item.Year
    })

  }
  const data = rangeDateReceiptStore.receipts.map((item: any) => {
    return item.TotalAmount
  })
  console.log("reportTypeSelected.value = ", reportTypeSelected.value)
  console.log("labels =" + labels.value + "datas = " + data)


  chartData.value = {
    labels: labels,
    datasets: [
      {
        label: 'ยอดขาย',
        backgroundColor: "#A79277",
        data: data
      }
    ]
  }

  loadingStore.finish()
  console.log("loadfinish")

}

async function refreshData() {
  await rangeDateReceiptStore.getReceiptInRangeDate(reportTypeSelected.value, formattedStartDate.value, formattedEndDate.value);
  await getView();

}

</script>

<template>

  <v-card title="สรุปยอดขาย">
    <v-container>

      <v-col>
        <v-row>
          <v-col cols="6">
            <v-row class="my-2">
              <v-col>
                <v-btn rounded="xl" size="compact" block @click="toggleDialog()">{{ dateRange }}</v-btn>
              </v-col>
            </v-row>
            <v-row class="my-2">
              <v-col>
                <v-select :items="items" v-model="reportTypeSelected"></v-select>
              </v-col>
              <v-col>
                <v-btn icon="mdi-cached" style="color: black" @click="refreshData()"></v-btn>
              </v-col>
            </v-row>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <v-card>
              <Line :data="chartData" :options="chartOptions" />
            </v-card>


          </v-col>

        </v-row>
        <v-dialog v-model="dialog">
          <v-card style="background-color: #fff2e1" max-width="40%">
            <v-card-title style="background-color: #d1bb9e">Please select Date range</v-card-title>
            <v-container>
              <v-row>
                <v-col>
                  <v-text-field append-inner-icon="mdi-calendar" label="Select Start Date"
                    v-model="selectedStartDate"></v-text-field>
                </v-col>
                <v-col>

                </v-col>
              </v-row>
              <v-row>
                <v-col>
                  <v-date-picker v-model="selectedStartDate" style="background-color: #ead8c0"></v-date-picker>
                </v-col>
              </v-row>
              <v-row>
                <v-col>
                  <v-text-field v-model="selectedEndDate" append-inner-icon="mdi-calendar"
                    label="Select End Date"></v-text-field>
                </v-col>
              </v-row>
              <v-row>
                <v-date-picker v-model="selectedEndDate" style="background-color: #ead8c0"></v-date-picker>
              </v-row>
            </v-container>
            <v-card-actions class="justify-end" style="background-color: #d1bb9e">
              <v-btn @click="toggleDialog()">cancel</v-btn>
              <v-btn @click="toggleDialog(), confirmSetbutton()">confirm</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>

    </v-container>
  </v-card>
  <v-card class="mt-4">
    <v-data-table :items="rangeDateReceiptStore.receipts"></v-data-table>
  </v-card>

</template>
<style scoped></style>
